package threads;
public class Bank {
    private String name;
	private String kontoNummer;
	private int berweisungsBetrag;
    private boolean verfgbar = false;

	private String bankLeitZahl;

	/**
	 * 
	 */
	public Bank(String name) {
		this.name = name;
	}

    public synchronized int auszahlen(String kontoNummer){
        while (verfgbar == false || !this.kontoNummer.equals(kontoNummer)) {
            try {
                wait();
            } catch (InterruptedException e) { }
        }
    	verfgbar = false; 
    	notifyAll();
		System.out.println("BANK        : Die " + this.name + " schreibt dem Konto " + kontoNummer + ", einen Betrag von " + berweisungsBetrag + " Euro gut");
    	return berweisungsBetrag;
    }

    public synchronized void einzahlen(String kontoNummer, int value) {
        while (verfgbar == true) {
            try {
                wait();
            } catch (InterruptedException e) { }
        }
        berweisungsBetrag = value;
        this.kontoNummer = kontoNummer;
        verfgbar = true;
		System.out.println("BANK        : Die " + this.getName() + " hat den Auftrag erhalten, fr das Konto " + kontoNummer + ", einen Betrag von " + berweisungsBetrag + " Euro zu berweisen");
        notifyAll();
    }
	/**
	 * @return String
	 */
	public String getName() {
		return name;
	}

	public String getBankLeitZahl() {
		return bankLeitZahl;
	}

	public void setBankLeitZahl(String bankLeitZahl) {
		this.bankLeitZahl = bankLeitZahl;
	}

}

